## ---- include = FALSE---------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(RPresence)

## ----tbl1,echo=F--------------------------------------------------------------
tbl=matrix(c(
2,2,0,2,0,2,0,2,0,2,0,2,
0,0,0,3,0,2,0,0,0,0,0,0,
2,0,0,2,0,0,1,0,0,0,0,0,
3,2,2,2,0,2,3,0,2,0,0,0),nrow=4,byrow=T)
det=tbl[,1:6]; conf=tbl[,7:12]
colnames(det)=colnames(conf)=paste0('survey',1:6)
rownames(det)=rownames(conf)=paste0('site',1:4)
knitr::kable(det,caption='Detection data')
knitr::kable(conf,caption='Confirmation data')

## ----ssmm1, echo=F------------------------------------------------------------
x=paste0('h_{',apply(expand.grid(1:3,1:6),1,paste,collapse=','),'}')
y=matrix(x,nrow=3); y1=paste0('$',y,'$')
set.seed(11); y=matrix(rbinom(18,1,.5),nrow=3)

colnames(y)=c('s1m1','s1m2','s2m1','s2m2','s3m1','s3m2')
rownames(y)=paste0('site',1:3)
knitr::kable(y,caption='Single-season Multi-method data format')

## ---- echo=F------------------------------------------------------------------
Neighbors=c('0100000000',
'1000000000',
'0001100000',
'0010100000',
'0011000000',
'0000001111',
'0000010111',
'0000011011',
'0000011101',
'0000011110')
Neighbors=cbind(1:length(Neighbors),Neighbors)
knitr::kable(Neighbors)

## ---- echo=F------------------------------------------------------------------
Neighbors=cbind(Neighbors,1)
Neighbors[5,3]=2; colnames(Neighbors)=c('site','Neighbors','Weight')
knitr::kable(Neighbors)

