% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/R-PRES.r
\name{coef.occMod}
\alias{coef.occMod}
\title{Extract regression coefficients from occupancy model, i.e., real parameter estimates}
\usage{
\method{coef}{occMod}(object, param = NULL, prob = 0, chat = 1)
}
\arguments{
\item{object}{an object of class \code{occMod} which is the result from fitting a model using the \code{\link{occMod}} function.}

\item{param}{name of model component to extract regression coefficients for}

\item{prob}{prob. level for conf. intervals (default=0.95)}

\item{chat}{value to adjust AIC to QAIC (AICc to QAICc) default=1}
}
\value{
a data.frame of the estimates and standard errors
}
\description{
Extract regression coefficients from occupancy model, i.e., real parameter estimates
}
\author{
Darryl MacKenzie
}
