% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/trolls_ms_doc.R
\name{trolls_ms}
\alias{trolls_ms}
\title{This dataset contains fictional data from a multi-season occupancy study.}
\format{
A list containing 5 data-frames.
\describe{
 \item{detHist}{(data.frame, 150x8) - detection history matrix}
 \item{siteCovs}{(data.frame, 150x2) - site-covariate matrix}
 \item{obs}{(data.frame 150x8) - observer covariate matrix}
 \item{preyDen}{(data.frame, 150x4) - prey density covariate matrix}
 \item{inputBetas}{(data.frame, 8x3) - initial beta values for model}
 }
}
\usage{
data(trolls_ms)
}
\description{
This dataset contains fictional data from a multi-season occupancy study.
}
\details{
Each row corresponds to a site. Columns correspond to surveys.
}
\examples{
\dontrun{

# Run simple multi-season occupancy model...
library(RPresence)

# create the pao
mypao <- createPao(trolls_ms$detHist, nsurveyseason=rep(2,4))

# run the dot model
dot <- occMod(data = pao,model=list(psi~1,epsilon~1,gamma~1,p~1),type = 'do.1')

# print dot estimates
print_one_site_estimates(dot)
}
}
