#include "SingAnal.h"
#include <math.h>
#define MISSNG -1
double CMLikeHet(double *Params, int NPar) {
    //   CMLike - computes the log-likelihood value for the Custom model (single-season) with heterogeneous p's
    //            for current parameter values (Params vector).
    //   
    //    This routine calls 'getParam' function to convert beta params to probabilities
    //    using the appropriate design matrix, and logit transformation.
    //
    int site, survey, notseen, T, N; 
    double psi=0, sumll=0, prd, prd2, p1, p2, pi;
    double getParam(int param_num, int param_grp, int row, int site, int srvy, double *Params, int transf, int LinkFn);
    T=SingSpec.T; N=SingSpec.N; //FILE *g=SingSpec.g;
    pi=getParam(1+2*T,2,0,0,0,Params,0,SingSpec.LinkFn);      // pi
    for (site=0; site<N; site++) {                            //    loop for each site (site=0 to N)...
        psi=prd=prd2=getParam(0,0,0,site,0,Params,0,SingSpec.LinkFn);  //   get logit-transformed psi param
		notseen=true;        
        for (survey=0; survey<T; survey++) {                          //   loop for each survey (survey=0 to T)...
            p1=getParam(1+  survey,1,survey,  site,survey,Params,0,SingSpec.LinkFn);  // p1=Pr(det | occupied)
            p2=getParam(1+T+survey,1,survey+T,site,survey,Params,0,SingSpec.LinkFn);  // p2= det.prob. grp2
			if (SingSpec.Data[site][survey]!=MISSNG  && p1>=0) {     //   if not missing data...
                if (SingSpec.Data[site][survey]==1) { prd *= p1; prd2*=p2; notseen=false;}  //  mult prd by p if detected,
                if (SingSpec.Data[site][survey]==0) { prd *= (1-p1); prd2*=(1-p2); }    //  mult prd by (1-p) if not detected,
            }
        }  //  end survey loop
		prd=prd*pi + prd2*(1-pi);
        if ( notseen ) prd+=(1-psi);     // if not in area (never seen), add 1-psi to likelihood 
        SingSpec.expval[site]=prd; 
        if (prd<=SingSpec.nearzero) sumll += SingSpec.det_hist_frq[site]*1000.;   //  add (# sites obs with this history)*1000 to sum
        else sumll -= SingSpec.det_hist_frq[site]*log(prd);        //  add -(# sites obs with this history)*log(like) to sum
		//fprintf(g,"%d %d%d%d%d %f %f %f\n",site,SingSpec.Data[site][0],
		//  SingSpec.Data[site][1],SingSpec.Data[site][2],SingSpec.Data[site][3],
		//  prd,SingSpec.det_hist_frq[site],SingSpec.det_hist_frq[site]*log(prd));
    } // end site loop        
    //fprintf(g,"%f - %f %f %f %f\n",sumll,psi,p1,p2,pi);
	return(sumll);
}
