#include "SingAnal.h"
#include <math.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>

struct goftable {
	int site, uhst, ucht, uniqdata, uniqloc, uniqcht, chtptr; char *hist; double coht, obs, exp, prb, chi;
};

int compare (const void *a, const void *b) {
	goftable *ia = (goftable *)a;
    goftable *ib = (goftable *)b;
    return (strcmp(ia->hist, ib->hist));
}

double gof_open(double *Params, int prnt) {
    
    //   gof test for multi-season (open) model 
 FILE *g; g=SingSpec.g;
    int i,j,jj,k,j2,N=SingSpec.N,T=SingSpec.T,nuniqdata=0,nuniqcht=0,misseq,chtfound,found,equal; 
	int site,srvy, isrvy, seasn, PrmyPeriods=SingSpec.PrmyPeriods,chtnum;
	int *uniqdata,*uniqloc,*uniqcht,*chtptr;
    double *expect,*cohort,*obs, *chtexp, temp,TestStat=0,exp2=0; //Nx=0,
    double eps=0,gam=0,cp,nearzero=1e-16;
    double psi=0, prd1=1, prd0, lprd0, lprd1, prb, chimax=999.;
    double getParam(int param_num, int param_grp, int row, int site, int srvy, double *Params, int transf, int LinkFn);
	char **hist;    
    uniqdata=new int[N]; uniqloc=new int[N]; uniqcht=new int[N]; 
	chtptr=new int[N]; chtexp=new double[N]; expect = new double[N];
    obs = new double[N]; cohort = new double[N];  hist = new char*[N];     
	
    for (i=0; i<N; i++) { 
        obs[i]=cohort[i]=chtexp[i]=0; hist[i]=new char[T+1]; hist[i][T]='\0';
        for (j=0; j<T; j++) { 
            if (SingSpec.Data[i][j]>=0) hist[i][j]='0'+SingSpec.Data[i][j]; 
            else hist[i][j]='.';
        }
    }
    for (i=0; i<N; i++) {    // for each history...
        //Nx+=SingSpec.det_hist_frq[i];
        for (found=-1,j=0; j<nuniqdata; j++) { // search table of unique histories
            jj=uniqdata[j];
            for (k=0,equal=1; k<T; k++) {
                if (SingSpec.Data[i][k]!=SingSpec.Data[jj][k]) equal=0;
            }
            if (equal==1 && found<0) found=j;
        }                
        for (chtfound=-1,j=0; j<nuniqcht; j++) { // search table of unique histories
            j2=uniqcht[j];
            for (k=0,misseq=1; k<T; k++) {
                if ((SingSpec.Data[i][k]<0 && SingSpec.Data[j2][k]>=0)||
                    (SingSpec.Data[i][k]>=0 && SingSpec.Data[j2][k]<0))misseq=0;
            }
            if (misseq==1 && chtfound<0) chtfound=j;
        }                
        if (found<0) { found=nuniqdata++; uniqdata[found]=i;}
        if (chtfound<0) {chtfound=nuniqcht++; uniqcht[chtfound]=i;}
        obs[found]+=SingSpec.det_hist_frq[found]; 
        cohort[chtfound]+=SingSpec.det_hist_frq[found]; 
        chtptr[found]=chtfound; uniqloc[i]=found;
    }

    // calculate test stat
	
	goftable *goftbl; goftbl=new goftable[nuniqdata]; 
	
    int pstart=(SingSpec.PrmyPeriods-1)*2+1;
    for (j=0; j<nuniqdata; j++) {
		site=uniqdata[j]; k=chtptr[j];
       	psi = getParam(0,0,0,site,0,Params,0,SingSpec.LinkFn); 
		prd0=1-psi; prd1=psi; if (SingSpec.OpenData[site][0]>0) prd0=0;
		for (srvy=isrvy=seasn=0; srvy<T; srvy++) {
			cp = getParam(pstart+srvy,3,srvy,site,srvy,Params,0,SingSpec.LinkFn);
            if (SingSpec.Data[site][srvy]!=-1 && cp>=0) {  //  if not missing data in this survey...
                if (SingSpec.Data[site][srvy]>0) prd1*=cp;
                else prd1*=(1-cp);
            }
			if (++isrvy==SingSpec.SecPeriods[seasn]) {
				if (srvy<(T-1)) {
					gam = getParam(seasn+1,1,seasn,site,seasn,Params,0,1);	eps=1-gam;
					if (SingSpec.Model<2) {
						eps = getParam(PrmyPeriods+seasn,2,seasn,site,seasn,Params,0,1);
						if (SingSpec.Alt_Param_Checked) eps=1-eps;
                    }
					lprd0=prd0; lprd1=prd1; prd0=lprd0*(1-gam)+lprd1*eps;
					if (SingSpec.OpenData[site][seasn+1]>0) prd0=0;
					prd1=lprd0*gam+lprd1*(1-eps);
				}
				seasn++; isrvy=0;
			}
        }
        prb=(prd0+prd1); expect[j]=prb*cohort[k]; chtexp[k]+=expect[j];
        temp = (obs[j]-expect[j])*(obs[j]-expect[j])/(expect[j]+nearzero);
		if (temp>chimax) temp=chimax;
		goftbl[j].site=site; goftbl[j].uhst=j; goftbl[j].ucht=k; goftbl[j].hist=hist[site]; 
		goftbl[j].obs=obs[j]; goftbl[j].coht=cohort[k]; goftbl[j].prb=prb; goftbl[j].exp=expect[j]; 
		goftbl[j].chi=temp;
    }

	size_t st_len = sizeof(goftable) / sizeof(struct goftable);
	qsort(goftbl, st_len, sizeof(struct goftable), compare);
	
	if(prnt>1) { 
        fprintf(g,"\n i history");
        for (i=0; i<T; i++) fprintf(g," "); 
        fprintf(g," Exp  Obs  cht#    Chi-sq   Chi-sq2\n");
    }
	
	for (i=0; i<nuniqdata; i++) {
		chtnum=goftbl[i].ucht; exp2=goftbl[i].coht-chtexp[chtnum];
		if (prnt>1) 
			fprintf(g,"%2d %s %10.6f %4.0f %4.0f %4d %10.4f %10.4f\n",
				i+1,goftbl[i].hist,goftbl[i].exp,goftbl[i].obs,goftbl[i].coht,chtnum+1,
				goftbl[i].chi,exp2);
		TestStat+=goftbl[i].chi+exp2;
		chtexp[chtnum]=goftbl[i].coht;
	}

    if (prnt>0) fprintf(g,">Test Statistic = %11.4f\n",TestStat);
    for (i=0; i<N; i++) delete [] hist[i];
    delete [] uniqdata; delete [] uniqloc; delete [] uniqcht; delete [] chtptr; 
    delete [] obs; delete [] cohort;  delete [] hist; delete [] expect;
    return(TestStat); delete [] goftbl;
}
