#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <wchar.h>

#include "SingAnal.h"
#include "rngs.h"
#define FALSE (1==0)

//#define RPres_check

TSingSpec SingSpec;

#ifndef noRPRES

//       R function declaration...
extern "C" {
int rpresence(int *NN, int *kk, int *nseasons, int *nmeth,                           // nsites, nsurveys, nseasons, nmethods
         int *dd, double *frq, int *nunitcov, double *unitcov, char **unitcovnames, // det.data, frequencies, nunitcovs, unitcov matrix (as vector)
         int *nsurvcov, double *survcov, char **survcovnames,                       // nsurvey covs, survcov array (as vector), survcovnames
         int *nsurveyseason,                                                        // vector of nsurveys per season,
         double *interval_lengths,                                                     // vector of interval lengths between seasons,
		 char **title,                                                            //  title
         char **unitnames, char **surveynames,                                    // vector of unitnames, surveynames
         int *dmdims,                                                             // vector of... dim(dm0), dim(dm1), dim(dm2),...
         char **dm0, char **rnames0,                                             // vectorized dm0,dm1,dm2,dm3,dm4,dm5,  vector of dm rownames
         double *iv, double *fv,                                                // vector of init values,  fixed values
		 int *neighbor,                                                        // neighbor matrix (NxN) as vector
		 double *neighbor_wgt,                                                // neighbor weights (Nx1) vector
         char **gname1,                                                       //  output filename (should include random chars for parallel runs)
         char **argv,                                                       // char vector of other run options
		 double *rvals);
}

//      R function definition...
int rpresence(int *NN, int *kk, int *nseasons, int *nmeth,                           // nsites, nsurveys, nseasons, nmethods
         int *dd, double *frq, int *nunitcov, double *unitcov, char **unitcovnames, // det.data, frequencies, nunitcovs, unitcov matrix (as vector)
         int *nsurvcov, double *survcov, char **survcovnames,                       // nsurvey covs, survcov array (as vector), survcovnames
         int *nsurveyseason,                                                        // vector of nsurveys per season,
         double *interval_lengths,                                                     // vector of interval lengths between seasons,
		 char **title,                                                            //  title
         char **unitnames, char **surveynames,                                    // vector of unitnames, surveynames
         int *dmdims,                                                             // vector of... dim(dm0), dim(dm1), dim(dm2),...
         char **dm0, char **rnames0,                                             // vectorized dm0,dm1,dm2,dm3,dm4,dm5,  vector of dm rownames
         double *iv, double *fv,                                                // vector of init values,  fixed values
		 int *neighbor,                                                        // neighbor matrix (NxN) as vector
		 double *neighbor_wgt,                                                // neighbor weights (Nx1) vector
         char **gname1,                                                       //  output filename (should include random chars for parallel runs)
         char **argv,                                                       // char vector of other run options
		 double *rvals) {

	int dmnum,irows,icols,argc=1,nsites=*NN;
	char tmps[1024],gname[1024],titstr[512];
	const char *autocovs[4]={"psi1","psiA","upsi","psiB"};
	strcpy(gname,gname1[0]);
	for (argc=0; strlen(argv[argc])>1; argc++);

#else

int presence(int *iargc, char **argv) {

	int argc=*iargc,TT=0,site,ierr=0,iopt=0,nsites=0; FILE *f; double tmp;
	int readdesmat(int *NPar, double **Params, FILE *f, int *modtype);
	char *s2, *s3, titstr[512]="no title", secper[2560]="", modsave[64]="no model name",
          cmtchar='|',  *p2, gname[1024]="presence.out", abc[]="_abc_AFH_DBI_EGC";
	char tab[4]="x ,"; tab[0]=9;   // delims = tab, comma, space

#endif

	extern TSingSpec SingSpec;
    int i=0,ii,j=0,jj,k,l,nbootstraps=0,nboot2=0,prnt=0,modtype=0,csum,nn,NPar;
    int nsitecov,nsampCov,notallmiss,seen,gof_err=0,maxstate=0,N,T,NrealPar=0,errcnt=0;
    time_t t1, t2; FILE *g; float t3;
    char s[65536], cwd[512]=".", *ss, fname[256]="genpres.pao", jname[256]="";

    double sim_psi=0.7, sim_p=0.4, poolcutoff=0.0,n=0,tsites=0, *Params,totsites=0, eps;
    int sim_nsites=200, sim_nintsites=100, sim_nintvisits=9, sim_nother=5, sim_removal=0, sim_nsims=100, do_sims=0;
    char sim_fname[256]="";

    double atof_comma(char *s);

    void Simulation(double PSI,double P,int NTot,int NInt,int TInt,int TOther,int Removal, int NSims, char *fname);
    void PreDefMod(int NBoot, int LoFBoot);
    void CustomMod(int NBoot, int nboot2, int NPar, double *Params,double poolcutoff);
    void OpenPopn(int NBoot, char *s, int NPar, double *Params, int nboot2);
    void OpenPopnMM(int NBoot, char *s, int NPar, double *Params, int nboot2);
    void TwoSpec(int NBoot, char *s, int NPar, double *Params);
    void TwoSpecMultiSeason(int NBoot, char *s, int NPar, double *Params);
    void RoyleMod(int NBoot, int goftest, int NPar, double *Params);
    void MSMod(int NBoot, int LoFBoot, int NPar, double *Params);
    void MSOpenPop(int NBoot, char *s, int NPar, double *Params);
    void StagEntModl(int nbootstraps, char *s, int NPar, double *Params);  //  single-season staggered entry model
    void OpenPopSD(int NPar, double *Params, int nboot2);
	void TwoSpecMisId(int NPar, double *Params);
    int chk_real_labels(char *lbl, int *modtype, int i, int dmnum);
	int check_desmat_rowlabels(int *modtype);

    int get_modl_num(char *s);
	void get_opendata(int modtype);

#ifdef RPres_check
	printf("=========== R func rpresence =============\n");
	printf("NN=%d kk=%d nseasons=%d nmeth=%d nunitcov=%d nsurvcov=%d\n",nsites,*kk,*nseasons,*nmeth,*nunitcov,*nsurvcov);
	for (i=0; i<(*kk); i++) printf(" %s",surveynames[i]); printf("\n");
	for (i=0; i<nsites; i++) {
		printf("%3d %15s ",i,unitnames[i]);
		for (j=0; j<(*kk); j++) printf("%d",dd[i*(*kk)+j]);
		printf(" %8.3f\n",frq[i]);
		for (j=0; j<*nunitcov; j++) printf(" %f",unitcov[i*(*nunitcov)+j]);
	}
	printf("\nnsurveyseasons:"); for (i=0; i<*nseasons; i++) printf(" %d",nsurveyseason[i]);
	printf("\ninterval lengths:"); for (i=1; i<*nseasons; i++) printf(" %d",interval_lengths[i-1]);
	printf("\nunitcovnames="); for (i=0; i<*nunitcov; i++) printf(" %s",unitcovnames[i]); printf("\n");
	printf("survcovnames=");
	for (i=0; i<*nsurvcov; i++) {
		printf(" %s\n",survcovnames[i]);
		for (j=0; j<(nsites * (*kk)); j++) printf(" %f",survcov[j]);
		printf("\n");
	}
	printf("\n"); int min=10; if (nsites<10) min=nsites;
	for (i=jj=0; i<6; i++) {
		printf("dim(%d)=%d %d\n",i,dmdims[i*2],dmdims[i*2+1]);
		if (dmdims[i+2]>0) jj+=dmdims[i*2]+1;
	}
	for (j=0; j<jj; j++) printf(" %s",dm0[j]); printf("\n");
	printf("rnames, fv:\n");
	for (i=jj=0; i<6; i++) {
		for (j=0; j<dmdims[i*2]; j++,jj++) printf(" %s %f\n",rnames0[jj],fv[jj]);
		printf("\n");
	}
	for (i=jj=0; i<6; i++) {
		printf("iv: i=%d\n",i);
		for (j=0; j<dmdims[i*2+1]; j++) printf(" %f",iv[jj]); printf("\n");
	}
	if (0) {
		printf("neighbor:\n");
		for (i=ii=jj=0; i<min; i++) {
			if (neighbor[0]!=999) {
				for (j=0; j<min; j++) printf(" %d",neighbor[ii++]); printf(" %f\n",neighbor_wgt[i]);
			}
		}
	}
	printf("gname=%s\n",*gname1);
	printf("argv="); for (i=0; strlen(argv[i])>0; i++) printf(" %s",argv[i]); printf("\n");
	SingSpec.Verbose=1;
#endif
    SingSpec.errstr=new char[1024]; strcpy(SingSpec.errstr,"");
    SingSpec.DMat = new double**[9]; SingSpec.Betaname=new char **[9];  SingSpec.DMat_ptr = new int**[9];
    SingSpec.Realname=new char **[9]; SingSpec.BetaFixed=new double*[9];
    SingSpec.LnkFn=new int *[9];
    char timstr[40]; time(&t1); strcpy(timstr,ctime(&t1)); timstr[strlen(timstr)-1]='\0';

    SingSpec.seed=(unsigned long) -time(NULL);  modtype=1;

	SingSpec.NSiteCov=0;        //  Number of site covariates
	SingSpec.NSampCov=0;        //  Number of sample(survey) covariates
	SingSpec.PrmyPeriods=1;     //  Number of Primary periods
	SingSpec.Nstates=1;                    //  Number of states(strata) in detection-history records
	SingSpec.NMethods=1;                   //  Number of methods per survey
	SingSpec.lmt=999999;           //  max number of sites to print for each real parameter
	SingSpec.rlmt=200;
	SingSpec.ifn=0;
	SingSpec.maxfn=50000;
	SingSpec.Verbose=1;
	SingSpec.novar=4;
    SingSpec.Groups=1;
    SingSpec.prmiss=1;
    SingSpec.UseNeighbor=SingSpec.Alt_Param_Checked=0;
	SingSpec.uncondpsi=SingSpec.do_chisq=SingSpec.nrandIV=SingSpec.nphantom=SingSpec.NMiss=0;
	SingSpec.Model=SingSpec.LinkFn=1;
	SingSpec.LikeNRSig=6;
	SingSpec.BootNRSig=4;             // numerical covergence options
    SingSpec.TSpecificP=SingSpec.MissClass=SingSpec.FalsePos=SingSpec.optmiz_done=SingSpec.UseAmoeba=SingSpec.multiseason=false;
	SingSpec.prnt_derived=SingSpec.dups=true;
    SingSpec.nearzero=1e-200;
	SingSpec.VCeps=.01;
	SingSpec.nthreads=1;
	SingSpec.simulating=SingSpec.phi_insteadof_eps=0;

    for (i=0; i<6; i++) SingSpec.NParKK[i]=SingSpec.NrowsDM[i]=0;

#ifdef RPres_check
    printf("getting args... (argc=%d)\n",argc);
#endif
    for (i=0; i<argc; i++) { 
		strcpy(s,argv[i]);
		if (SingSpec.Verbose>0) printf("==>%d : %s\n",i,s);
		if (i>0 && (s[0]<65 || s[0]>122)) { printf("wtf:%d %c\n",s[0],s[0]); break; }
#ifndef RPres_check
        if (strstr(s,"quiet")  !=NULL || strstr(s,"QUIET")!=NULL) SingSpec.Verbose=0;
#endif
		if (strstr(s,"verbose")!=NULL) SingSpec.Verbose=2;
        if (strstr(s,"debug")  !=NULL) SingSpec.Verbose=3;
		if (s[1]=='=') {
			if (s[0]=='i') strcpy(fname,s+2);   //  input pao filename
			if (s[0]=='j') strcpy(jname,s+2);   //  input design matrix filename
			if (s[0]=='l' || s[0]=='o') strcpy(gname,s+2);   //    output filename
		  }
    }
	
#ifdef WIN32
	wchar_t gnamew[512]=L""; i=strlen(gname);
	mbstowcs(gnamew,gname,strlen(gname)); // convert output filename from string type to wide string type
	//printf("open using wfopen (l=%d)...\n",i); printf("gnamew:%s\n",gname);
    if ((g=SingSpec.g = _wfopen(gnamew,L"w"))==NULL) {printf("shit\n"); exit(1);}
#else
    if ((g=SingSpec.g = fopen(gname,"w"))==NULL) {printf("crap\n"); exit(1);}
#endif
//		if (strstr(gname,"/dev/null")==NULL) { printf("\nError opening output file [%s]\n",gname); return(1); }

    fprintf(g,"\n\nPRESENCE - Presence/Absence-Site Occupancy data analysis\n");
    fprintf(g,"%s,       Version %s.\n",timstr,VERSN);
    fprintf(g,"- - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");

	if (SingSpec.Verbose>0) printf("===PRESENCE Version %s.  Verbose=%d.\n",VERSN, SingSpec.Verbose);

	if (getcwd(cwd, sizeof(cwd)) != NULL) {
		if (SingSpec.Verbose>0) printf("\nCurrent working dir: %s\n", cwd);
	}
	else
		perror("getcwd() error");

	for (i=0; i<argc; i++) { // strlen(argv[i])>0; i++) {
	  if (argv[i][0]<65 || argv[i][0]>122) break;
      strcpy(s,argv[i]); j=(int)strlen(s); fprintf(g,"==>%s\n",s);
	  if (SingSpec.Verbose>0) printf("==>%s\n",s);
      for (k=0; k<j && s[k]!='='; k++) s[k]=tolower(s[k]);
      ss=strstr(s,"echo")    ; if (ss !=NULL) prnt=1;
      ss=strstr(s,"prmiss=")    ; if (ss !=NULL) SingSpec.prmiss=atoi(ss+7);
      ss=strstr(s,"name=")   ; if (ss !=NULL) strcpy(SingSpec.modname,ss+5);
      ss=strstr(s,"maxfn=")  ; if (ss !=NULL)  SingSpec.maxfn=atoi(ss+6);
      ss=strstr(s,"lmt=")    ; if (ss !=NULL && strstr(s,"rlmt")==NULL) SingSpec.lmt=atoi(ss+4);
      ss=strstr(s,"rlmt=")   ; if (ss !=NULL) SingSpec.rlmt=atoi(ss+5);
      ss=strstr(s,"link=c")  ; if (ss !=NULL) SingSpec.LinkFn=2;
      ss=strstr(s,"link=s")  ; if (ss !=NULL) SingSpec.LinkFn=4;
      ss=strstr(s,"nsig=")   ; if (ss !=NULL) SingSpec.LikeNRSig=atoi(ss+5);
      ss=strstr(s,"zero=")   ; if (ss !=NULL) SingSpec.nearzero=pow(10.,(double)(-atoi(ss+5)));
      ss=strstr(s,"nboot=")  ; if (ss !=NULL) nbootstraps=atoi(ss+6);
      ss=strstr(s,"boot2=")   ; if (ss !=NULL) nboot2=atoi(ss+6);
      ss=strstr(s,"pool=")   ; if (ss !=NULL) poolcutoff=atof(ss+5);
      ss=strstr(s,"nstates="); if (ss !=NULL) SingSpec.Nstates=atoi(ss+8);
      ss=strstr(s,"amoeba")  ; if (ss !=NULL) SingSpec.UseAmoeba=1;
      ss=strstr(s,"seed")    ; if (ss !=NULL) SingSpec.seed = atol(ss+5);
      ss=strstr(s,"vceps")   ; if (ss !=NULL) SingSpec.VCeps = atof(ss+6);
      ss=strstr(s,"neighb")  ; if (ss !=NULL) SingSpec.UseNeighbor = 2;
      ss=strstr(s,"nrand=")  ; if (ss !=NULL) SingSpec.nrandIV=atoi(ss+6);

	  ss=strstr(s,"nthreads=")  ; if (ss !=NULL) SingSpec.nthreads=atoi(ss+9);

//        output options for SE's and VC matrix
//	  Option 1:  only compute likelihood and beta estimates, no beta var-cov matrix or beta SE's (useful for faster model selection of big models or simulations)
//    Option 2: compute but don't print beta var-cov matrix so we get beta SE's, don't compute real params
//    Option 3: compute and print beta beta var-cov matrix, don't compute real params (I think this is what you want for RPresence)
//    Option 4: (default) compute real params and real var-cov matrix, don't print either var-cov matrix.
//    Option 5: compute real params and real var-cov matrix, print only beta var-cov matrix.
//    Option 6: print both var-cov matrices.

      if (strcasecmp(s,"nose") == 0) SingSpec.novar = 1;
      if (strcasecmp(s,"betavc") == 0) SingSpec.novar = 2;
      if (strcasecmp(s,"noreal") == 0) SingSpec.novar = 3;
      if (strcasecmp(s,"realbetavc") == 0) SingSpec.novar = 5;
      if (strcasecmp(s,"bothvc") == 0) SingSpec.novar = 6;


      ss=strstr(s,"chsq")           ; if (ss !=NULL) SingSpec.do_chisq = 1;
      ss=strstr(s,"noderived")      ; if (ss !=NULL) SingSpec.prnt_derived = false;
      ss=strstr(s,"nodups")         ; if (ss !=NULL) SingSpec.dups = false;
      ss=strstr(s,"model=")         ; if (ss !=NULL) modtype=get_modl_num(s);
      ss=strstr(s,"sim_psi=")       ; if (ss !=NULL) { sim_psi=atof(ss+8); do_sims=1;}
      ss=strstr(s,"sim_p=")         ; if (ss !=NULL) { sim_p=atof(ss+6); do_sims=1;}
      ss=strstr(s,"sim_nsites=")    ; if (ss !=NULL) { sim_nsites=atoi(ss+11); do_sims=1;}
      ss=strstr(s,"sim_nintsites=") ; if (ss !=NULL) { sim_nintsites=atoi(ss+14); do_sims=1;}
      ss=strstr(s,"sim_nintvisits="); if (ss !=NULL) { sim_nintvisits=atoi(ss+15); do_sims=1;}
      ss=strstr(s,"sim_nother=")    ; if (ss !=NULL) { sim_nother=atoi(ss+11); do_sims=1;}
      ss=strstr(s,"sim_removal")    ; if (ss !=NULL) { sim_removal=1; do_sims=1;}
      ss=strstr(s,"sim_nsims=")     ; if (ss !=NULL) { sim_nsims=atoi(ss+10); do_sims=1;}
      ss=strstr(s,"sim_fname=")     ; if (ss !=NULL) { strcpy(sim_fname,ss+10); do_sims=1;}
    }

	fprintf(g,"seed=%ld\n",SingSpec.seed); SelectStream(0); PutSeed(SingSpec.seed);

    eps=pow(pow(10.0, -SingSpec.LikeNRSig), 1.0/3.0);
    fprintf(g,"varcov: nsig=%d eps=%e\n",SingSpec.LikeNRSig,eps);

    if (do_sims>0) {
        if (SingSpec.Verbose>0) printf("calling Simulation(psi=%f p=%f N=%d n=%d k=%d nother=%d removal=%d nsims=%d fname=%s)\n",
               sim_psi,sim_p,sim_nsites,sim_nintsites,sim_nintvisits,sim_nother,sim_removal,sim_nsims,sim_fname);
        Simulation(sim_psi,sim_p,sim_nsites,sim_nintsites,sim_nintvisits,sim_nother,sim_removal,sim_nsims,sim_fname);
		return(0);
    }
#ifndef noRPRES
    N=SingSpec.N=*NN; T=SingSpec.T=*kk;
#else
    if ((f=fopen(fname,"rt"))==NULL) {
		printf("\nError opening input file (%s)\n",fname); return(1);
	}
    for (p2=fgets(s,sizeof(s),f); s[0]==cmtchar && p2!=NULL; p2=fgets(s,sizeof(s),f))
		if (SingSpec.Verbose>2) printf("..>%s",s);
    i=sscanf(s,"%d %d %d",&N,&T,&iopt); if (SingSpec.Verbose>2) printf(">>s=%s\n",s);
    fprintf(g,"%s N,T-->%d,%d\n",modsave,N,T);
	SingSpec.N=nsites=N; SingSpec.T=T;
#endif
    if (SingSpec.Verbose>0)printf("N,T-->%d,%d verbose=%d\n",N,T,SingSpec.Verbose);
	if (N<1) {
		printf("\n******* Input error - number of sites = zero ****\n");
		fprintf(g,"\n******* Input error - number of sites = zero ****\n");
		return(1);
	}
    SingSpec.Data         = new int*[N];    SingSpec.OpenData     = new int*[N];
    SingSpec.area         = new double[N];  SingSpec.det_hist_frq =new double[N];
    SingSpec.expval       = new double[N+1];
    SingSpec.neighbor     = new char*[N];   SingSpec.neighbor_wgt = new double[N];
    SingSpec.neighbor_lst = new int*[N];
	for (i=ii=jj=0; i<N; i++) {
		SingSpec.neighbor[i]=new char[N]; SingSpec.neighbor_lst[i]=new int[N];
		SingSpec.neighbor_wgt[i]=SingSpec.expval[i]=0;
		SingSpec.det_hist_frq[i]=SingSpec.area[i]=1;
#ifndef noRPRES
		SingSpec.det_hist_frq[i]=frq[i];
		if (neighbor[0]!=999) SingSpec.neighbor_wgt[i]=neighbor_wgt[jj++];
		for (j=0; j<N; j++)
			if (neighbor[0]!=999) SingSpec.neighbor[i][j]=neighbor[ii++];
#endif
	}
    //              ****************    get detection history data *********************
    fprintf(g,"\n\n");
    for (ii=i=0,csum=0; i<N; i++) {
        SingSpec.Data[i] = new int[T+1]; SingSpec.OpenData[i] = new int[T+1];
		for (j=0; j<=T; j++) SingSpec.Data[i][j]=SingSpec.OpenData[i][j]=-1;
#ifdef noRPRES
        p2=fgets(s,sizeof(s),f); l=strlen(s); if (s[l-1]<' ') s[l-1]='\0';
        if (SingSpec.Verbose>1) printf("p/a data(%d):%s\n",i,s);
        s2=strtok(s,tab);
#endif
        for (seen=notallmiss=j=0; j<T; j++,ii++) {
#ifndef noRPRES
			if (dd[ii]<0) SingSpec.NMiss++;
			else { SingSpec.Data[i][j]=dd[ii]; notallmiss=1;}
#else
			if(s2!=NULL) {
				if (s2[0]>='A' && s2[0]<='c') {
					k=SingSpec.Data[i][j]=(int)(strchr(abc,s2[0])-abc);
				}
				else
                if (s2[0]>='-' && s2[0]<='9') {
					if (s2[0]=='-' || s2[0]=='.') SingSpec.NMiss++;
                    else { SingSpec.Data[i][j]=atoi(s2); notallmiss=1;}
                }
                else
                    fprintf(g,"\n Error: invalid data, site:%d - %s\n",i,s);
            }
			s2=strtok(NULL,tab);
#endif
            if(SingSpec.Data[i][j]>0) seen=1;
            if(SingSpec.Data[i][j]>maxstate) maxstate=SingSpec.Data[i][j];
            csum+=(j+1)*('2'+SingSpec.Data[i][j]); if (csum>=65536) csum-=65536;
        }
#ifdef noRPRES
        if (s2!=NULL) if (s2[0]>='0' && s2[0]<='9') {
            s3=strchr(s2,','); if (s3!=NULL) s3[0]='.';   //  change "," to "." for spanish decimal point
            SingSpec.det_hist_frq[i]=atof(s2);
        }
#endif
        totsites+=SingSpec.det_hist_frq[i];
        if (seen>0) n+=SingSpec.det_hist_frq[i];
        if (notallmiss==1) tsites+=SingSpec.det_hist_frq[i];
        if (SingSpec.det_hist_frq[i]>0 && SingSpec.det_hist_frq[i]!=1) gof_err=1;
    }
    if (prnt>=1) {
        for (i=0; i<N; i++) { fprintf(g,"%4d:",i+1);
            for (j=0; j<T; j++) fprintf(g,"%c",(SingSpec.Data[i][j]>=0?SingSpec.Data[i][j]+'0':'.'));
            if (SingSpec.det_hist_frq[0]!=1) fprintf(g," %f",SingSpec.det_hist_frq[i]);
            fprintf(g,"\n");
        }
    }
    SingSpec.Nstates=maxstate+1;
    if (SingSpec.Verbose>0) {
		printf("Data checksum = %d\n\n",csum);
		printf("\n\n********* Input Data summary *******\n");
		printf("Number of sites                = %d\n", (int)(totsites+.5));
		printf("Number of sampling occasions   = %d\n", T);
		printf("Number of states               = %d\n", SingSpec.Nstates);
		printf("Number of missing observations = %d\n", SingSpec.NMiss);
		printf("Data checksum = %d\n\n",csum);
    }
	fprintf(g,"\n\n********* Input Data summary *******\n");
    fprintf(g,"Number of sites                = %d\n", (int)(totsites+.5));
    fprintf(g,"Number of sampling occasions   = %d\n", T);
    fprintf(g,"Number of states               = %d\n", SingSpec.Nstates);
    fprintf(g,"Number of missing observations = %d\n", SingSpec.NMiss);
    fprintf(g,"Data checksum = %d\n\n",csum);

    SingSpec.NSiteCov=SingSpec.NSampCov=nsitecov=nsampCov=0; nn=N;

#ifndef noRPRES
    SingSpec.NSiteCov=nsitecov=*nunitcov; SingSpec.NSampCov=nsampCov=*nsurvcov;
#else
    for(s2=fgets(s,sizeof(s),f); s[0]==cmtchar && strlen(s)>0; s2=fgets(s,sizeof(s),f))
		if (SingSpec.Verbose>1) printf("..>%s",s);
    if (s2!=NULL) SingSpec.NSiteCov=atoi(s); //i=sscanf(s,"%d",&SingSpec.NSiteCov);
    fprintf(g,"NSiteCovs-->%d\n",SingSpec.NSiteCov);
#endif


    nsitecov=SingSpec.NSiteCov; SingSpec.CovNames=new char*[nsitecov];
	nn=N; SingSpec.SiteCov=new double*[nn];
	if(SingSpec.Verbose>0) printf("NSiteCovs-->%d %d\n",nsitecov,SingSpec.NSiteCov);

    for (i=0; i<nn; i++) {
        SingSpec.SiteCov[i]=new double[nsitecov];
        for (j=0; j<nsitecov; j++) SingSpec.SiteCov[i][j]=0;
    }

    fprintf(g,"NSiteCovs-->%d\n",SingSpec.NSiteCov);
    SingSpec.CovNames=new char*[nsitecov];

	//              ****************    get site covariate data from pao file *********************
#ifndef noRPRES
    for (i=0; i<nsitecov; i++) {    //  RPresence
		l=strlen(unitcovnames[i]); SingSpec.CovNames[i]=new char[l+1]; strcpy(SingSpec.CovNames[i],unitcovnames[i]);
        if (SingSpec.Verbose>0) printf("site_covname[%d]=%s\n",i,SingSpec.CovNames[i]);
        fprintf(g,"site_covname[%d]=%s\n",i,SingSpec.CovNames[i]);
		for (ii=k=0; k<nn; k++) {
			for (j=0; j<*nunitcov; j++) SingSpec.SiteCov[k][j]=unitcov[ii++];
		}
    }
#else
    for (i=0; i<nsitecov; i++) {      //   no RPresence
        p2=fgets(s,sizeof(s),f);  if (SingSpec.Verbose>1) printf("..>%s",s);
        s[strlen(s)-1]=0;  l=strlen(s)-1;
		if (l>0 && s[l]<' ') s[l]='\0';
        SingSpec.CovNames[i]=new char[l+1]; strcpy(SingSpec.CovNames[i],s);
        if(SingSpec.Verbose>0) printf("site_covname[%d]=%s\n",i,SingSpec.CovNames[i]);
        fprintf(g,"site_covname[%d]=%s\n",i,SingSpec.CovNames[i]);
        for (site=0; site<nsites; site++) {
            p2=fgets(s,sizeof(s),f);
            if (strpbrk(s,"0123456789")!=NULL) {
                s3=strchr(s,','); if (s3!=NULL) s3[0]='.';   //  change "," to "." for spanish decimal point
                SingSpec.SiteCov[site][i]=atof(s);
            }
            if (strcmp(SingSpec.CovNames[i],"area")==0) SingSpec.area[site]=SingSpec.SiteCov[site][i];
        }
    }

#endif

    //           ************** get sample covars ********
#ifndef noRPRES
	//           RPresence
    SingSpec.NSampCov=nsampCov=*nsurvcov; if(SingSpec.Verbose>0) printf("NSampCovs-->%d\n",nsampCov);
    fprintf(g,"NSampCovs-->%d\n",nsampCov);
    SingSpec.CovNames2=new char*[nsampCov]; SingSpec.SampCov=new double**[nsampCov];
    for (ii=k=0; k<nsampCov; k++) {
		l=strlen(survcovnames[k]); SingSpec.CovNames2[k]=new char[l+1];
        strcpy(SingSpec.CovNames2[k],survcovnames[k]);
        if (SingSpec.Verbose>0) printf("samp_covname[%d]=%s\n",k,SingSpec.CovNames2[k]);
        fprintf(g,"samp_covname[%d]=%s\n",k,SingSpec.CovNames2[k]);
        SingSpec.SampCov[k]=new double*[N];
        for (j=0; j<nsites; j++) SingSpec.SampCov[k][j]=new double[T];
	}
	for (i=0; i<T; i++)
		for (j=0; j<nsites; j++)
			for (k=0; k<nsampCov; k++) {
				SingSpec.SampCov[k][j][i]=survcov[ii++];
				if (strcmp(survcovnames[k],"confirm")==0)
					SingSpec.Data[j][i]= ((int)SingSpec.SampCov[k][j][i])<<2 | SingSpec.Data[j][i];
			}
#else
		//   no RPresence
	for(s2=fgets(s,sizeof(s),f); s[0]==cmtchar && strlen(s)>0; p2=fgets(s,sizeof(s),f))
	if (SingSpec.Verbose>1) printf("..>%s",s);
    if (s2!=NULL) nsampCov=atoi(s); //i=sscanf(s,"%d",&nsampCov);

    SingSpec.NSampCov=nsampCov; if(SingSpec.Verbose>0) printf("NSampCovs-->%d\n",nsampCov);
    fprintf(g,"NSampCovs-->%d\n",nsampCov);
    SingSpec.CovNames2=new char*[nsampCov]; SingSpec.SampCov=new double**[nsampCov];
    for (k=0; k<nsampCov; k++) {
        for(p2=fgets(s,sizeof(s),f); s[0]==cmtchar && strlen(s)>0; p2=fgets(s,sizeof(s),f))
        s[strlen(s)-1]=0; l=strlen(s)-1; if (l>0 && s[l]<' ') s[l]='\0';
        SingSpec.CovNames2[k]=new char[l];
		strcpy(SingSpec.CovNames2[k],s);
        if(SingSpec.Verbose>0) printf("samp_covname[%d]=%s.\n",k,SingSpec.CovNames2[k]);
        fprintf(g,"samp_covname[%d]=%s\n",k,SingSpec.CovNames2[k]);
        SingSpec.SampCov[k]=new double*[N];
        for (j=0; j<nsites; j++) {
            SingSpec.SampCov[k][j]=new double[T]; for (i=0; i<T; i++) SingSpec.SampCov[k][j][i]=0;
            p2=fgets(s,sizeof(s),f); s2=strtok(s,tab);
            for (i=0; i<T; i++) {
                if (s2!=NULL) {
                    s3=strchr(s2,','); if (s3!=NULL) s3[0]='.';   //  change "," to "." for spanish decimal point
                    tmp=atof(s2);
                    if ((s2[0]=='-' || s2[0]=='.') && s2[1]<=' ') {
						if (SingSpec.Data[j][i]>=0) {
							if (++errcnt<10)
								fprintf(g,"***WARNING: missing covariate with non-missing data: %s site:%d survey:%d\n",SingSpec.CovNames2[k],j,i);
						}
					}
                    else {
						SingSpec.SampCov[k][j][i]=tmp;
						if (strcmp(SingSpec.CovNames2[k],"confirm")==0) {
							SingSpec.Data[j][i]= atoi(s2)<<2 | SingSpec.Data[j][i];
						}
					}
                }
                if (s2[strlen(s2)-1]!='\n')	s2=strtok(NULL,tab);
            }
        }
    }
#endif

    if (prnt) fprintf(g,"\nSite Covariates:\n");
    if (SingSpec.NSiteCov>0) {
        if (prnt>0) {
			for (i=0; i<SingSpec.NSiteCov; i++) fprintf(g,"%s ",SingSpec.CovNames[i]);
            fprintf(g,"\n");
            for (j=0; j<nsites; j++) { fprintf(g,"%d:",j);
                for (i=0; i<SingSpec.NSiteCov; i++) fprintf(g,"%f ",SingSpec.SiteCov[j][i]);
                fprintf(g,"\n");
            }
        }
	}
    if (prnt) fprintf(g,"\n Sample Covariates:");
    for (k=0; k<SingSpec.NSampCov; k++) {
        if (prnt) fprintf(g,"\n  Covariate %d: %s\n",k,SingSpec.CovNames2[k]);
        for (j=0; j<nsites; j++) {
            for (i=0; i<T; i++) {
                if (prnt) fprintf(g,"%1.1f ",SingSpec.SampCov[k][j][i]);
                if (SingSpec.SampCov[k][j][i]<-9998 && SingSpec.Data[j][i]>=0 && errcnt<10) {
                    fprintf(g,"***WARNING(%d): missing covariate (%s) with non-missing data\n***         site:%d survey:%d\n",
					               ++errcnt,SingSpec.CovNames2[k],j,i);
                }
            }
            if (prnt) fprintf(g,"\n");
        }
    }

	//  *********    get secondary periods (and number of methods)  ******************

	SingSpec.SecPeriods = new int[T+1]; SingSpec.IntervalLengths=new double[T+1];
	for (i=0; i<T; i++) SingSpec.IntervalLengths[i]=1;

#ifndef noRPRES
    SingSpec.PrmyPeriods=*nseasons;
	for (i=0; i<*nseasons; i++) SingSpec.SecPeriods[i]=nsurveyseason[i];
	for (i=1; i<*nseasons; i++) SingSpec.IntervalLengths[i-1]=interval_lengths[i-1];
	SingSpec.NMethods=*nmeth; strcpy(titstr, title[0]);
#else
    if (!feof(f)) {
		p2=fgets(secper,sizeof(secper),f);
	}
    else strcpy(secper,"1");

	if (!feof(f)) {
		p2=fgets(titstr,sizeof(titstr),f);
		if (strncasecmp(titstr,"inter",5)==0) {
			s2=strtok(titstr,"=");
			for (i=0; s2; i++) {
				SingSpec.IntervalLengths[i-1]=atof(s2);
				s2=strtok(NULL,",");
			}
			strcpy(titstr,"no title");
			p2=fgets(titstr,sizeof(titstr),f);
		}

	}

	if (strchr(secper,';')!=NULL) {
		strcpy(s,secper);               // copy input string with secper and possibly nmeth to s
		s2=strtok(s,";");               // get chars before ';' and ignore
		s2=strtok(NULL,";");            // get chars after ';' and use as nmeth
		if (strlen(s2)>0) SingSpec.NMethods=atoi(s2);
	}
	if (SingSpec.NMethods<2) SingSpec.NMethods=1;
	//printf("nmeth:%d\n",SingSpec.NMethods);
	if (strlen(secper)>0) {
		s2=strtok(secper,",");             //  get chars before 1st ','
		j=atoi(s2);
		for(TT=T,i=1; s2; i++) {
			if(atoi(s2)>0) j=atoi(s2);
			if (j<1) j=1;
			if (i<=T) SingSpec.SecPeriods[i-1]=j;
			TT-=j;
			s2=strtok(NULL,",");
		}
		if (i<=T && j>1) SingSpec.SecPeriods[i-1]=j;
		for (;TT>0;TT-=j) if (i<=T) SingSpec.SecPeriods[i++]=j;
		SingSpec.PrmyPeriods=--i; if (i>T) i=T;
	}
#endif

    if (SingSpec.Verbose>0) printf("Primary periods=%d Secondary periods:",SingSpec.PrmyPeriods);
    fprintf(g,"Primary periods=%d Secondary periods:",SingSpec.PrmyPeriods);
    for (i=0;i<SingSpec.PrmyPeriods;i++) {
	  if (SingSpec.Verbose>0) printf(" %d",SingSpec.SecPeriods[i]);
	  fprintf(g," %d",SingSpec.SecPeriods[i]);
	}
    fprintf(g,"\n");
	fprintf(g,"Interval lengths between seasons:\n");
    for (i=1;i<SingSpec.PrmyPeriods;i++) {
		fprintf(g," %f",SingSpec.IntervalLengths[i-1]);
		if ((i % 10) == 0) fprintf(g,"\n");
	}
    fprintf(g,"\n");

	if (SingSpec.Verbose>0) printf("\nNumber of methods/survey = %d\n",SingSpec.NMethods);

	//       **************  get sitenames *****************8
	SingSpec.sitename=new char*[N]; SingSpec.surveyname=new char*[T];
	if (SingSpec.Verbose) printf("N=%d T=%d Verbose=%d\n",N,T,SingSpec.Verbose);

#ifndef noRPRES
    for (i=0; i<N; i++) {
	    SingSpec.sitename[i]=new char[1024];
	    strcpy(SingSpec.sitename[i],unitnames[i]);
	}
	//   **********************   get survey names *****************
    for (i=0; i<T; i++) {
		SingSpec.surveyname[i]=new char[1024];
		strcpy(SingSpec.surveyname[i],surveynames[i]);
	}
#else
    strcpy(s,"");
    for (i=0; i<N; i++) {
        SingSpec.sitename[i]=new char[1024]; snprintf(SingSpec.sitename[i],1024,"site_%d",i+1);
        if (!feof(f)) {
            p2=fgets(s,sizeof(s),f); l=strlen(s)-1;
            if (l>0) {
                j=strchr(s,'\n')-s; if (j>=0) s[j]='\0';
                if (s[l]<' ') s[l]='\0';
				for (j=0; j<31; j++) SingSpec.sitename[i][j]=s[j];
				s[31]='\0';
            }
        }
    }
	//   **********************   get survey names *****************
	for (i=0; i<T; i++) {
        SingSpec.surveyname[i]=new char[1024];
        snprintf(SingSpec.surveyname[i],1024,"survey_%d",i+1);
        if (!feof(f)) {
            p2=fgets(s,sizeof(s),f); l=strlen(s)-1;
            if (l>0) {
            	j=strchr(s,'\n')-s;
				if (j>=0 && j<1024) s[j]='\0';
            	if (s[l]<' ') s[l]='\0';
            	if (j>0 && j<1024) strcpy(SingSpec.surveyname[i],s);
			}
        }
    }
	fclose(f);
#endif

    fprintf(g,"- - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");
    fprintf(g," %s\n",titstr);
    fprintf(g,"- - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");
    time(&t2);
	if (SingSpec.Verbose>0)
		printf("N=%d T=%d Groups=%d bootstraps=%d\n",N,T,SingSpec.Groups,nbootstraps);
    fprintf(g,"N=%d T=%d Groups=%d bootstraps=%d\n",N,T,SingSpec.Groups,nbootstraps);

#ifndef noRPRES
	NrealPar=NPar=0;
	for (ii=jj=dmnum=0; dmnum<6; dmnum++) {
		irows=dmdims[dmnum*2]; icols=dmdims[dmnum*2+1];
		if (SingSpec.Verbose>0) printf("\nMatrix %d: rows=%d, cols=%d modtype=%d\n",dmnum+1,irows,icols,modtype);
		fprintf(g,"\nMatrix %d: rows=%d, cols=%d\n",dmnum+1,irows+(irows>0),icols+(icols>0));
		if (icols>0) {
		  if (SingSpec.Verbose>0) printf("            -");
		  for (j=0; j<icols; j++) if (SingSpec.Verbose>0) printf(",%c%d",'a'+dmnum,j+1);
		  if (SingSpec.Verbose>0) printf("\n");
		  fprintf(g,"            -");
		  for (j=0; j<icols; j++) fprintf(g,",%c%d",'a'+dmnum,j+1);
		  fprintf(g,"\n");
		}
		SingSpec.NrowsDM[dmnum]=irows; NrealPar+=irows;
		SingSpec.NParKK[dmnum]=icols; NPar+=icols;
        SingSpec.DMat[dmnum] = new double*[irows];   //  SingSpec.DMat, SingSpec.DMat_ptr used to obtain real value in design matrix
        SingSpec.DMat_ptr[dmnum] = new int*[irows];  //  If DMat_ptr==0, use value in SingSpec.DMat
        SingSpec.Realname[dmnum]=new char*[irows];   //  If DMat_ptr==3001, use "psi1" or "PsiA" in des.mat.
        SingSpec.Betaname[dmnum]=new char*[icols];   //  If DMat_ptr==3002, use "psiB" in des.mat.
        SingSpec.BetaFixed[dmnum]=new double[icols]; //  if Dmat_ptr==i (where i>0), use i'th site covar.
        SingSpec.LnkFn[dmnum]=new int[irows];        //  if Dmat_ptr==i (i<0), use -i'th sample covar.
        for (j=0; j<icols; j++) {
		    SingSpec.Betaname[dmnum][j]=new char[1024];
			strcpy(SingSpec.Betaname[dmnum][j],"");
            SingSpec.BetaFixed[dmnum][j]=1.1e44;
		}
		if (irows<1) jj++;   //  des.mat from R cannot be NULL, so each des.mat has at least a "0"
		for (i=0; i<irows; i++) {
            SingSpec.DMat[dmnum][i]=new double[icols];
			SingSpec.DMat_ptr[dmnum][i]=new int[icols];
			l=strlen(dm0[jj]);
            SingSpec.Realname[dmnum][i]=new char[l+1];
			strcpy(SingSpec.Realname[dmnum][i],dm0[jj++]); //rnames0[ii++]);
			fprintf(g,"%-13s",SingSpec.Realname[dmnum][i]);
			if (SingSpec.Verbose>0) printf("%-13s ",SingSpec.Realname[dmnum][i]);
			j=chk_real_labels(SingSpec.Realname[dmnum][i],&modtype, i, dmnum);
            for (j=0; j<icols; j++,jj++) {
				strcpy(tmps,""); SingSpec.DMat[dmnum][i][j]=atof(dm0[jj]);
				SingSpec.DMat_ptr[dmnum][i][j]=0;      //  check list of site covars
                for (k=0; k<SingSpec.NSiteCov; k++) {
					if (strcmp(dm0[jj],SingSpec.CovNames[k])==0) break;
				}
				if (k<SingSpec.NSiteCov) {
					SingSpec.DMat_ptr[dmnum][i][j]=k+1;
					strcpy(tmps,SingSpec.CovNames[k]);
				}
                else {				 //  check list of sample covars
                    for (k=0; k<SingSpec.NSampCov; k++) if (strcmp(dm0[jj],SingSpec.CovNames2[k])==0) break;
					if (k<SingSpec.NSampCov) { SingSpec.DMat_ptr[dmnum][i][j]=-(k+1); strcpy(tmps,SingSpec.CovNames2[k]); }
                    else {				//  check list of autologistic covars
				        if (strncmp(dm0[jj],"psi1",4)==0) { SingSpec.DMat_ptr[dmnum][i][j]=3001; SingSpec.Model=5;}
                        if (strncmp(dm0[jj],"psi1",4)==0 || strncmp(dm0[jj],"psiA",4)==0) { SingSpec.UseNeighbor=2;}
                        if (strncmp(dm0[jj],"psiB",4)==0) { SingSpec.DMat_ptr[dmnum][i][j]=3002;}
                        if (strncmp(dm0[jj],"upsi1",5)==0) { SingSpec.Model=5; SingSpec.uncondpsi=1; }
				        for (k=0; k<4; k++)  if (strcmp(dm0[jj],autocovs[k])==0) break;
						if (k<4) {
				        	SingSpec.DMat_ptr[dmnum][i][j]=3001+(k>2);
				        	SingSpec.UseNeighbor=2;
				        	if (k<3) SingSpec.Model=5;
				        	if (k==2) SingSpec.uncondpsi=1;
				        	strcpy(tmps,autocovs[k]);
				        }
					}
				}
				if ((SingSpec.DMat_ptr[dmnum][i][j]!=0) | (SingSpec.DMat[dmnum][i][j]!=0))
					if (strlen(SingSpec.Betaname[dmnum][j])<1) {
						if (dm0[jj][0]!='1') snprintf(SingSpec.Betaname[dmnum][j],1024,"%s.%s",SingSpec.Realname[dmnum][i],dm0[jj]);
					    else                  snprintf(SingSpec.Betaname[dmnum][j],1024,"%s",SingSpec.Realname[dmnum][i]);
					}
				fprintf(g,"  %s",dm0[jj]); if (SingSpec.Verbose>0) printf(" %s",dm0[jj]);
			}
            fprintf(g,"\n"); if (SingSpec.Verbose>0) printf("\n");
            SingSpec.LnkFn[dmnum][i]=0;
		}
		for (j=0; j<icols; j++) if (strlen(SingSpec.Betaname[dmnum][j])<1) snprintf(SingSpec.Betaname[dmnum][j],1024,"%c%d",'a'+dmnum,j+1);
	}
	SingSpec.fixed = new double[NrealPar];
	for (i=0; i<NrealPar; i++) SingSpec.fixed[i]=fv[i];
#else
	//    Presence only code...
    if (modtype!=0) {
        if (strlen(jname)<1) {           //  if no design matrix file specified...
            strcpy(jname,fname); i=strlen(jname);   //   use pao filename, replacing 'pao' with 'dm'
            jname[i-3]='d'; jname[i-2]='m'; jname[i-1]='\0';
        }
        if (strlen(jname)>1) {
            if (SingSpec.Verbose>0) printf("opening %s...\n",jname);
            if ((f=fopen(jname,"rt"))==NULL) {
                printf("\nError opening input dm file (%s)\n",jname);
                fprintf(g,"\nError opening input dm file (%s)\n",jname);
                return(1);
            }
            if (SingSpec.Verbose>0) printf("reading design matrix file...\n");
            ierr=readdesmat(&NPar,&Params,f,&modtype); fclose(f);
        }
    }
	if (ierr>0) {   // abort if error
	    printf("\nErro:%s\n",SingSpec.errstr);
	    fprintf(g,"\nErro:%s\n",SingSpec.errstr);
		return(1);
	}

    if(SingSpec.Verbose>0) printf("==>dmfile=[%s] modtype=%d\n",jname,modtype);
    if (strlen(jname)>0 && SingSpec.NrowsDM[0]>1) {
		if (SingSpec.Verbose>0)
			printf("nrowsdm=%d %d %d %d %d %d\n",SingSpec.NrowsDM[0],SingSpec.NrowsDM[1],SingSpec.NrowsDM[2],SingSpec.NrowsDM[3],SingSpec.NrowsDM[4],SingSpec.NrowsDM[5]);
	    if (strncmp(SingSpec.Realname[0][1],"thet",4)==0 && strncmp(SingSpec.Realname[1][0],"p1",2)==0)	 {
			SingSpec.NMethods=T/(SingSpec.NrowsDM[0]-1);
			if (SingSpec.Verbose>0) printf("\nNumber of Methods per survey = %d\n",SingSpec.NMethods);
			fprintf(g,"\nNumber of Methods per survey = %d\n",SingSpec.NMethods);
		}
	}
#endif

	j=check_desmat_rowlabels(&modtype);

	if (modtype==0) {
	    NPar =  1 /*psi*/ + (SingSpec.Groups-1) + SingSpec.Groups*(1 + (SingSpec.TSpecificP*(SingSpec.T-1)));
		SingSpec.NrowsDM[0]=SingSpec.NrowsDM[1]=1;
		SingSpec.DMat[0]=new double*[1]; SingSpec.DMat[0][0]=new double[1]; SingSpec.DMat[0][0][0]=1;
		SingSpec.DMat[1]=new double*[SingSpec.T];
		for (i=0; i<SingSpec.T; i++) SingSpec.DMat[1][i]=new double[1];
		SingSpec.DMat[1][i][0]=1;
    }
    Params=new double[NPar+1];
#ifndef noRPRES
	for (i=0; i<NPar; i++) Params[i]=iv[i];
#else
	for (i=0; i<=NPar; i++) Params[i]=0;
#endif

    //readdesmat(&NPar,&Params,f,&modtype); fclose(f);
	//                  allocate space for real param estimates for each site

	for (i=NrealPar=0; i<6; i++) NrealPar+=SingSpec.NrowsDM[i];
	SingSpec.realParmEst = new double*[NrealPar+1];
	SingSpec.finalBetaEst = new double[NPar+1];
	for (i=0; i<NrealPar; i++) SingSpec.realParmEst[i] = new double[N];
	SingSpec.realParmEst[NrealPar]=NULL;
	SingSpec.finalVCmat = new double*[NPar];
	for (i=0; i<NPar; i++) SingSpec.finalVCmat[i]=new double[NPar];
	if (SingSpec.PrmyPeriods<2 && modtype!=3) fprintf(g,"Naive occupancy estimate       = %6.4f\n\n",n / tsites);

	if (modtype==7 && SingSpec.NrowsDM[4]>0) modtype=10;

	for (i=k=0; i<6; i++) {
	    for (j=0; j<SingSpec.NrowsDM[i]; j++,k++) {
			if (SingSpec.fixed[k]>-990) fprintf(g,"fix(%d) %s=%f\n",k,SingSpec.Realname[i][j],SingSpec.fixed[k]);
		}
	}
	if (SingSpec.Verbose>0) printf("modtype=%d\n",modtype);
    if (SingSpec.PrmyPeriods<2 && modtype!=3) fprintf(g,"Naive occupancy estimate       = %6.4f\n\n",n / tsites);
	get_opendata(modtype); fprintf(g,"\nmodtype=%d\n",modtype);
    if (modtype==1 && nbootstraps>0 && gof_err>0) {
        fprintf(g,"\n============================================================\n");
        fprintf(g,"Note: GOF only works with unsummarized data\n");
        fprintf(g,"============================================================\n");
        nbootstraps=0;
    }
	if (SingSpec.UseNeighbor>0) {
		for (i=0; i<N; i++)
			for (j=k=0; j<N; j++)
				if (SingSpec.neighbor[i][j]>0) SingSpec.neighbor_lst[i][k++]=j;
	}

    switch (modtype) {
		case 0:
			PreDefMod(nbootstraps,nboot2);     // pre-defined single=season model
			break;

		case 1:
		case 9:
			CustomMod(nbootstraps,nboot2,NPar,Params,poolcutoff);// single-season model  (possibly multi-method
			break;

		case 2:            //  multi-season models
			if (SingSpec.NrowsDM[0]>1) {
				if (strncmp(SingSpec.Realname[0][1],"theta",5)==0) OpenPopnMM(nbootstraps,s,NPar,Params,nboot2);
				else                                                 OpenPopn(nbootstraps,s,NPar,Params,nboot2);
			} else                                                 OpenPopn(nbootstraps,s,NPar,Params,nboot2);
			break;

		case 3:
			TwoSpecMultiSeason(nbootstraps,s,NPar,Params);
			break;

		case 4:
			RoyleMod(nbootstraps,nboot2,NPar,Params);
			break;

		case 5:  //  multi-strata models
			if (SingSpec.multiseason) MSOpenPop(nbootstraps,s,NPar,Params);
			else                      MSMod(nbootstraps,nboot2,NPar,Params);
			break;

		case 6:
			MSOpenPop(nbootstraps,s,NPar,Params);   //  multi-season,multi-strata model
			break;

		case 8:
			StagEntModl(nbootstraps,s,NPar,Params); //  single-season staggered entry model
			break;

		case 7:
		case 10:
			OpenPopSD(NPar,Params,nboot2);  //  multi-season spatial-dependence model
			break;

		case 11: TwoSpecMisId(NPar,Params);
    }

    time(&t2); t3=t2-t1; if (SingSpec.Verbose>0) printf("\nCPU time= %1.0f seconds (%1.2f min)\n",t3,t3/60.);
    fprintf(g,"\nCPU time= %1.0f seconds (%1.2f min)\n",t3,t3/60.);
	fprintf(g,"\n\nPRESENCE - Presence/Absence-Site Occupancy data analysis\n");
    fprintf(g,"%s,       Version %s.\n",timstr,VERSN);
    fprintf(g,"- - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");
	fclose(g); if (SingSpec.Verbose>1) printf("free memory...\n");

	//rvals[0]=2*SingSpec.finalLL;      //   return values to R...
	//for (i=0; i<NPar; i++) rvals[i+1]=SingSpec.finalBetaEst[i];
	//for (i=0,ii=NPar+1; i<NPar; i++)
	//	for (j=0; j<NPar; j++) rvals[ii++]=SingSpec.finalVCmat[i][j];

	delete [] SingSpec.area; delete [] SingSpec.det_hist_frq;  delete [] SingSpec.expval;
	delete [] SingSpec.neighbor_wgt; delete [] Params;
	delete [] SingSpec.SecPeriods;
	delete [] SingSpec.fixed;
	delete [] SingSpec.finalBetaEst;

	for (i=0; i<N; i++) {
		delete [] SingSpec.Data[i];
		delete [] SingSpec.neighbor_lst[i];
		delete [] SingSpec.neighbor[i];
		delete [] SingSpec.OpenData[i];
		delete [] SingSpec.sitename[i];
	}
	delete [] SingSpec.Data; delete [] SingSpec.neighbor_lst;
	delete [] SingSpec.neighbor; delete [] SingSpec.OpenData; delete [] SingSpec.sitename;

	for (i=0; i<nn; i++) delete [] SingSpec.SiteCov[i];
	delete [] SingSpec.SiteCov;

	for (i=0; i<T; i++) delete [] SingSpec.surveyname[i];
	delete [] SingSpec.surveyname;

	for (i=0; i<nsampCov; i++) 	{
		delete [] SingSpec.SampCov[i];
		delete [] SingSpec.CovNames2[i];
	}
	delete [] SingSpec.SampCov; delete [] SingSpec.CovNames2;
	for (i=0; i<NrealPar; i++) delete [] SingSpec.realParmEst[i];
	delete [] SingSpec.realParmEst;

	for (i=0; i<NPar; i++) delete [] SingSpec.finalVCmat[i];
	delete [] SingSpec.finalVCmat;

	for (i=0; i<6; i++) {
		for (j=0; j<SingSpec.NrowsDM[i]; j++) {
			delete [] SingSpec.DMat[i][j]; delete[] SingSpec.DMat_ptr[i][j];
			delete [] SingSpec.Realname[i][j];
		}
		delete [] SingSpec.DMat[i]; delete[] SingSpec.DMat_ptr[i];
		delete [] SingSpec.Realname[i];

		for (j=0; j<SingSpec.NParKK[i]; j++) delete [] SingSpec.Betaname[i][j];
		delete [] SingSpec.Betaname[i];

		delete [] SingSpec.LnkFn[i];
		delete [] SingSpec.BetaFixed[i];
	}
	delete [] SingSpec.DMat; delete[] SingSpec.DMat_ptr;
	delete [] SingSpec.Realname; delete [] SingSpec.Betaname;
	delete [] SingSpec.LnkFn; delete [] SingSpec.BetaFixed;

    if (SingSpec.Verbose>0) printf("quit rpresence (main2c)\n");
	return(0);
}

#ifdef noRPRES
int main(int argc, char **argv) {
	int i; i=presence(&argc, argv);
	printf("quitting main...(%d)\n",i);
	return(i);
}
#endif
