# test_bobcat.R
test_that("test_bobcat.R", {

  #    read detection history data from csv file,
  csv<-read.csv(system.file("extdata/Bobcat.csv",package="RPresence"))

  dethist=csv[,2:8];  #  detection data in cols 2-8
  sitenames=csv[,1]  #  sitenames in 1st column
  sitecov=csv[,9:18]
  sitecov$Park_ID=as.factor(sitecov$Park_ID)
  observer=csv[,19:25] # observer covariate in cols 19-25
  temp=csv[,26:32]  #  temperature covariate in cols 26-32
  survcov=data.frame(obs=as.factor(unlist(observer)),temp=unlist(temp))

  #          create input "pao" object, for use with occMod function
  data=createPao(dethist,unitcov=sitecov,survcov=survcov,
                 title="Bobcat example",unitnames=sitenames)

  mods=list(); i=1
  mods[[i]]<-occMod(model=list(psi~1,p~1),            data=data,threads=2)

  expect_equal(round(mods[[1]]$aic,3),2996.497)
})
