#
#rm(list=ls()); setwd('c:/users/jhines/onedri~1/hines/a/aatmp')

N=500          # sites
K=6            # surveys
lambda=2       # number of individuals per site
p=.2           # prob(detect inidividual per site,survey)
set.seed(4321) # seed number for random numbers

pop=rpois(N,lambda) # simulate number of individuals per site

count=NULL          # for each survey ...
for (k in 1:K) {    #    simulate number of individuals detected
  count=cbind(count, rbinom(N, pop, p))
}

library(RPresence)
pao=createPao(count)

m2=occMod(list(lambda~1, r~1), data=pao, type='rpc')
#print(print_one_site_estimates(m2))
#print(print_one_site_estimates(m2,derived=T))

pao$det.data[pao$det.data>1]=1
m3=occMod(list(lambda~1, c~1), data=pao, type="RNH")
#print(print_one_site_estimates(m3))
#print(print_one_site_estimates(m3,derived=T))


expect_equal(round(m2$real$lambda$est[1],3),2.048)
expect_equal(round(m2$real$r$est[1],3),0.199)
expect_equal(round(m2$derived$psi$est[1],3),0.871)
expect_equal(round(m2$derived$N$est[1],3),1024.19)

expect_equal(round(m3$real$lambda$est[1],3),2.148)
expect_equal(round(m3$real$c$est[1],3),0.195)
expect_equal(round(m3$derived$psi$est[1],3),0.883)
expect_equal(round(m3$derived$N$est[1],3),1073.83)

